"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dsl2_1 = require("../runtime/dsl2");
require("../watchers/system");
var prog = new dsl2_1.Program("hover");
prog.attach("system");
prog.attach("html");
prog
    .block("Top level div", function (_a) {
    var find = _a.find, record = _a.record;
    var main = find("main");
    return [
        main.add("children", [
            record("html/style")
                .add("text", "\n            div { width: 100px; height: 100px; margin: 25px; }\n            .effect.visible { opacity: 1; }\n            .cause { background-color: #75507b; }\n            .effect { background-color: #8f5902; opacity: 0; }\n          "),
            record("html/div", { sort: 0 })
                .add("class", "cause")
                .add("tag", "html/onmouseenter")
                .add("tag", "html/onmouseleave"),
            record("html/div", { sort: 1 })
                .add("class", "effect")
                .add("tag", "effect")
        ])
    ];
});
prog
    .commit("mouseenter", function (_a) {
    var find = _a.find, record = _a.record;
    var elem = find("effect");
    var event = find("html/event/mouseenter");
    return [
        elem.add("class", "visible")
    ];
});
prog
    .commit("mouseleave", function (_a) {
    var find = _a.find, record = _a.record;
    var elem = find("effect");
    var event = find("html/event/mouseleave");
    return [
        elem.remove("class", "visible")
    ];
});
prog
    .block("Translate elements into html", function (_a) {
    var find = _a.find, record = _a.record;
    var elem = find("html/div");
    return [elem.add("tag", "html/element").add("tagname", "div")];
})
    .block("Translate elements into html", function (_a) {
    var find = _a.find, record = _a.record;
    var elem = find("html/style");
    return [elem.add("tag", "html/element").add("tagname", "style")];
});
prog.inputEavs([[1, "tag", "main"]]);
//# sourceMappingURL=hover.js.map