"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("../watchers/watcher");
var prog = new watcher_1.Program("UI Demo");
prog.attach("ui");
prog.block("test field-table", function (_a) {
    var find = _a.find, record = _a.record;
    var turtle = find("turtle");
    return [
        record("ui/field-table", "ui/editable", { turtle: turtle }).add("field", [
            record({ attribute: "attr1", value: "val1", froof: "blue" }),
            record({ attribute: "attr1", value: "val1-2" }),
            record("ui/editable", { attribute: "attr2" }).add("value", [
                "foo", "bar", "baz"
            ]),
            record({ attribute: "attr3" }).add("value", [
                1
            ]),
        ])
    ];
});
prog.block("Display field changes", function (_a) {
    var find = _a.find, record = _a.record;
    var turtle = find("turtle");
    var table = find("ui/field-table", { turtle: turtle });
    var field_change = table.change;
    var cell = field_change.cell;
    return [
        record("ui/column", "changelog", { field_change: field_change, style: record({ "align-self": "flex-start", flex: "0 0 auto", border: "1px solid black", padding: 10, margin: 10 }) }).add("children", [
            record("ui/text", { sort: cell.column, text: cell.column + ": " + cell.initial + " => " + cell.value })
        ])
    ];
});
prog.block("Decorate the changes with whatever extra info was on the field.", function (_a) {
    var find = _a.find, lookup = _a.lookup, not = _a.not, record = _a.record;
    var changelog = find("changelog");
    var field_change = changelog.field_change;
    var _b = lookup(field_change.field), attribute = _b.attribute, value = _b.value;
    attribute != "attribute";
    attribute != "value";
    // not(() => {attribute == "tag"; value == "ui/editable"});
    return [
        changelog.add("children", [
            record("ui/text", "changelog", { sort: "__" + attribute, text: attribute + ": " + value })
        ])
    ];
});
prog.block("Demo autocomplete.", function (_a) {
    var find = _a.find, record = _a.record;
    var person = find("person");
    return [
        record("ui/autocomplete", { placeholder: "person..." }).add("completion", [
            record({ text: person.name })
        ])
    ];
});
prog.commit("Test autocomplete data", function (_a) {
    var find = _a.find, record = _a.record;
    find("turtle");
    return [
        record("person", { name: "Jeff Smith" }),
        record("person", { name: "George Washington" }),
        record("person", { name: "Svenka Peterson" }),
        record("person", { name: "Jeff Bloom" }),
        record("person", { name: "Jean Gray" })
    ];
});
prog.inputEavs([
    [1, "tag", "turtle"]
]);
//# sourceMappingURL=ui-demo.js.map