export declare let workspaces: {
    [name: string]: string;
};
export declare function loadWorkspaces(neue: any): void;
export declare function add(name: string, directory: string): void;
/** Given an explicit workspace, return the contents of the file. */
export declare function get(file: string, workspace?: string): string | undefined;
/** Using the inferred workspace from the file path, return the contents of the file. */
export declare function find(file: string): string | undefined;
/** Given an explicit workspace, update the contents of the file. */
export declare function set(file: string, content: string, workspace?: string): void;
/** Using the inferred workspace from the file path, update the contents of the file. */
export declare function save(file: string, content: string): void;
export declare function getWorkspaceFromPath(file: string): string | undefined;
export declare function getRelativePath(file: string, workspace: string): string | undefined;
export declare function getAbsolutePath(file: string, workspace: string): string;
export declare function pack(): string;
export declare function fetchAll(workspace: string): any;
