"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var runtime_1 = require("./runtime");
//--------------------------------------------------------------------
// Comparisons
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "compare/>",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a > b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/>=",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a >= b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/<",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a < b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/<=",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a <= b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/!=",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a != b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/==",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a == b) ? [] : undefined;
    }
});
//--------------------------------------------------------------------
// Math
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "math/+",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a + b];
    }
});
runtime_1.makeFunction({
    name: "math/-",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a - b];
    }
});
runtime_1.makeFunction({
    name: "math/*",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a * b];
    }
});
runtime_1.makeFunction({
    name: "math//",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a / b];
    }
});
runtime_1.makeFunction({
    name: "math/floor",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.floor(a)];
    }
});
runtime_1.makeFunction({
    name: "math/ceil",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.ceil(a)];
    }
});
runtime_1.makeFunction({
    name: "math/round",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.round(a)];
    }
});
runtime_1.makeFunction({
    name: "math/sin",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.sin(a / 180 * Math.PI)];
    }
});
runtime_1.makeFunction({
    name: "math/cos",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.cos(a / 180 * Math.PI)];
    }
});
runtime_1.makeFunction({
    name: "math/tan",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.tan(a / 180 * Math.PI)];
    }
});
runtime_1.makeFunction({
    name: "math/max",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [Math.max(a, b)];
    }
});
runtime_1.makeFunction({
    name: "math/min",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [Math.min(a, b)];
    }
});
runtime_1.makeFunction({
    name: "math/mod",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a % b];
    }
});
runtime_1.makeFunction({
    name: "math/abs",
    args: { a: "number" },
    returns: { result: "number" },
    apply: function (a) {
        return [Math.abs(a)];
    }
});
runtime_1.makeFunction({
    name: "math/toFixed",
    args: { a: "number", b: "number" },
    returns: { result: "string" },
    apply: function (a, b) {
        return [a.toFixed(b)];
    }
});
// makeFunction({
//   name: "math/range",
//   args: {start: "number", stop: "number"},
//   returns: {result: "string"},
//   apply: (start:number, stop:number) => {
//     if(start > stop) {
//       [stop, start] = [start, stop];
//     }
//     for(let ix = start; ix < stop; ix += 1) {
//     }
//     return [a.toFixed(b)];
//   }
// });
//--------------------------------------------------------------------
// String
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "string/replace",
    args: { text: "string", replace: "string", with: "string" },
    returns: { result: "string" },
    apply: function (text, replace, _with) {
        var result = text.split(replace).join(_with);
        return [result];
    }
});
runtime_1.makeFunction({
    name: "string/get",
    args: { text: "string", at: "number" },
    returns: { result: "string" },
    apply: function (text, at) {
        if (at > text.length)
            return;
        return [text[at - 1]];
    }
});
runtime_1.makeFunction({
    name: "string/uppercase",
    args: { text: "string" },
    returns: { result: "string" },
    apply: function (text) {
        return [text.toLocaleUpperCase()];
    }
});
runtime_1.makeFunction({
    name: "string/lowercase",
    args: { text: "string" },
    returns: { result: "string" },
    apply: function (text) {
        return [text.toLocaleLowerCase()];
    }
});
runtime_1.makeFunction({
    name: "string/index_of",
    args: { text: "string", substring: "string" },
    returns: { result: "number" },
    apply: function (text, substring) {
        var ix = ("" + text).indexOf(substring);
        if (ix == -1)
            return;
        return [ix];
    }
});
//--------------------------------------------------------------------
// Random
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "random/number",
    args: { seed: "any" },
    returns: { result: "number" },
    initialState: {},
    apply: function (seed) {
        var state = this.state;
        var result = state[seed];
        if (result === undefined) {
            result = state[seed] = Math.random();
        }
        return [result];
    }
});
//--------------------------------------------------------------------
// Eve internal
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "eve/internal/gen-id",
    args: {},
    variadic: true,
    returns: { result: "string" },
    apply: function (values) {
        // @FIXME: This is going to be busted in subtle cases.
        //   If a record exists with a "1" and 1 value for the same
        //   attribute, they'll collapse for gen-id, but won't join
        //   elsewhere.  This means aggregate cardinality will disagree with
        //   action node cardinality.
        return [values.join("|")];
    }
});
runtime_1.makeFunction({
    name: "eve/internal/concat",
    args: {},
    variadic: true,
    returns: { result: "string" },
    apply: function (values) {
        return [values.join("")];
    }
});
var SumAggregate = (function (_super) {
    __extends(SumAggregate, _super);
    function SumAggregate() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SumAggregate.prototype.add = function (state, resolved) {
        state.total += resolved[0];
        return state;
    };
    SumAggregate.prototype.remove = function (state, resolved) {
        state.total -= resolved[0];
        return state;
    };
    SumAggregate.prototype.getResult = function (state) {
        return state.total;
    };
    SumAggregate.prototype.newResultState = function () {
        return { total: 0 };
    };
    ;
    return SumAggregate;
}(runtime_1.AggregateNode));
exports.SumAggregate = SumAggregate;
//# sourceMappingURL=stdlib.js.map