import { RawValue } from "./watcher";
import { DOMWatcher } from "./dom";
export interface Instance extends HTMLElement {
    __element?: RawValue;
    __styles?: RawValue[];
    __sort?: RawValue;
    listeners?: {
        [event: string]: boolean;
    };
}
export declare class HTMLWatcher extends DOMWatcher<Instance> {
    tagPrefix: string;
    createInstance(id: RawValue, element: RawValue, tagname: RawValue): Instance;
    createRoot(id: RawValue): Instance;
    addAttribute(instance: Instance, attribute: RawValue, value: RawValue): void;
    removeAttribute(instance: Instance, attribute: RawValue, value: RawValue): void;
    sentInputValues: {
        [element: string]: string[];
        [element: number]: string[];
    };
    setup(): void;
}
